% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metrics_functions.R
\name{GAR}
\alias{GAR}
\title{Compute the Generalized Anti-Robinson (GAR) score}
\usage{
GAR(mat_sorted, w = NULL)
}
\arguments{
\item{mat_sorted}{A numeric, symmetric sorted distance matrix.}

\item{w}{Window size (integer). If NULL, uses global comparisons (equivalent to AR).}
}
\value{
The GAR score (the total number of violations).

Please refer to \code{\link{GAP}} for complete usage examples.
}
\description{
Calculates the number of Anti-Robinson violations within a specified window \code{w},
allowing evaluation of local structural consistency in the reordered matrix.
}
