% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metrics_functions.R
\name{RGAR}
\alias{RGAR}
\title{Compute the Relative Generalized Anti-Robinson (RGAR) score}
\usage{
RGAR(mat_sorted, w = NULL)
}
\arguments{
\item{mat_sorted}{A numeric, symmetric sorted distance matrix.}

\item{w}{Window size (integer). If NULL, uses global comparisons (equivalent to AR normalized).}
}
\value{
The RGAR score (between 0 and 1).

Please refer to \code{\link{GAP}} for complete usage examples.
}
\description{
This function returns the relative GAR score, representing the proportion of
Anti-Robinson violations over the total number of evaluated triplets.
}
